label ablauf_bump_explode	
	dw    	11*64+48,11*64+56,11*64+60,12*64+0,12*64+8,12*64+16,12*64+24,12*64+32
	dw	12*64+40,12*64+48,12*64+56,13*64+0,13*64+8,13*64+16
	dw	13*64+24,13*64+32,13*64+40,13*64+48,14*64+0,14*64+8,14*64+16
	dw	14*64+24,14*64+32,14*64+40,14*64+48,14*64+56
ablaufz	dd	0       ;48
ablaufzaehler dd 0
bump_explode_init:                 
	mov	esi,objekt_bump_explod_ort
	call	loadobjekt
	ladebild dateihinter_bump_explod_gr 2 pal  dateihinter_bump_explod_ort hintergrund
	lea	eax,texture
	mov	dummydword,eax            	                                      
	ladebild dateibump_gr 3 pal  dateibump_ort dummydword
 	lea	eax,phongmap                                                          
 	mov	dummydword,eax                                                        
	ladebild dateiphong_bump_explod_gr 3 pal dateiphong_bump_explod_ort dummydword
        call	init_bump1
   	@wait9:                
   	cmp    	rowsplayed,9*64             
   	jl     	@wait9         
        mov	ecx,32*320/4   
        mov	edi,video                                
        mov	esi,hintergrund
        rep	movsd          
   	@wait10:                                                            
   	cmp    	rowsplayed,9*64+24
   	jl     	@wait10                   
        mov	ecx,32*320/4                 
        rep	movsd
   	@wait11:                                 
   	cmp    	rowsplayed,9*64+32         
   	jl     	@wait11           
        mov	ecx,32*320/4       
        rep	movsd             
   	@wait12:                        
   	cmp   	rowsplayed,9*64+48      
   	jl    	@wait12                 
        mov	ecx,32*320/4                          
        rep	movsd                   
   	@wait13:                        
   	cmp    	rowsplayed,9*64+56      
   	jl     	@wait13                    
        mov	ecx,32*320/4            
        rep	movsd                   
   	@wait14:                        
   	cmp    	rowsplayed,9*64+60
   	jl     	@wait14                    
        mov	ecx,40*320/4                 
        rep	movsd             
        mov	esi,hintergrund                  
        mov	edi,fertigbild             
        mov	ecx,16000          
        rep	movsd                
ret                                             
                                                 
bump_explode:                                    
	mov	zweg,1000    ;1000                   
	mov	backtimer1,384
	mov	backtimer,0   
 	mov	ablaufz,0                        
 	mov	timer,0                          
        @zeichne3d_bumpexpl:                       
		cmp    	rowsplayed,11*64+40      
 		ja    	@keine_bew                
	 	      	mov  	ebx,backtimer1
	 		add  	ebx,128                      
	 		movsx	eax,w [cosinus+ebx*2]        
			mov	xweg,eax                     
			movsx	eax,w [sinus+ebx*2]          
			add	eax,750  ;750                
			mov	zweg,eax
		@keine_bew:                                  
		mov	eax,timer
   		mov	gradx,ax                             
   		mov	grady,ax                             
		mov	gradz,ax                             
 	  	mov	bx,gradx                             
 	  	mov	di,30;grady           
 	  	mov    	si,gradz
 	  	movzx	ebp,anzahlvektor
 	  	@morphingloop:                          
		   	push   	di bx si
 	  		mov   	ax,[zrot+ebp*2]
 	  		shr  	ax,15 
 			add	di,ax          
		  	mov	ax,[yrot+ebp*2]
 			shr    	ax,2
 		      	add	bx,ax
   		       	mov	ax,[xrot+ebp*2]
 		       	shr	ax,2 
 	 	       	add	si,ax
	  	       	call  	rotieren
	  	       	call	rotatenormals
	  	       	pop	si bx di
	  	  	dec    	ebp 
 	  	jns	@morphingloop
 	 	call	filter_sichtbare_faces
 	 	mov	lm,0                  
	 	movsx	eax,anzahlsichtbar    
		cmp	eax,0                 
 		jl	@keinquick            
		 	mov    	rm,eax        
		 	call   	quicksort     
		cmp	rowsplayed,11*64+50  ;48
		jb	@normal_bump          
				cmp    	ablaufz,26
				jae   	bump_explode_ende
				mov	eax,130
				add	eax,backtimer
				add	eax,backtimer
				add	eax,backtimer        
				mov	sprung,ax
	   		  	call  	drawall_bump_explode 
		 	 	jmp   	@bump_explode        
	 	 	@normal_bump:                        
			 	call 	drawall_bump         
   		 	@bump_explode:                       
			cmp	rowsplayed,13*64+56 
			jb	@normal_draw
   		 	call 	setze_blur          
   		 	jmp	@keinquick          
   		 	@normal_draw:               
   		 	call	setze_hinter        
   		@keinquick:                 
   	 	jmp    	@zeichne3d_bumpexpl                 
bump_explode_ende:                         
	call	switchoff                  
        mov	ecx,16000                                   
        mov	edi,video                  
	xor	eax,eax                    
        rep	stosd                      
ret                                        
