phong_texture_morph_init:
	mov	esi,objekt_text_phong_m_ort
        call	loadobjekt                            
	ladebild dateihinter_text_phong_m_gr 2 pal dateihinter_text_phong_m_ort hintergrund
	lea	eax,phongmap
	mov	dummydword,eax           	             
	ladebild dateiphong_text_m_gr 3 pal dateiphong_text_m_ort dummydword
	lea	eax,texture                 
	mov	dummydword,eax              	             
	ladebild  dateitext_phong_m_gr 3 pal dateitext_phong_m_ort dummydword
   	lea   	edi,shadingstufe
   	mov	esi,dateimatrix_m_ort      
   	mov	ecx,2048/4                 
    	rep	movsd                          
ret                                            
                                               
phong_texture_morph:                           
	call	switchon
   	mov	zweg,1600                      
   	mov	yweg,1000                      
   	mov	backtimer,220
 	mov	timer,0
        @zeichne3d_text_morph:                 
        	cmp	rowsplayed,15*64+55    
        	ja	@schon_drinn           
        	mov  	eax,backtimer
        	shl	eax,2        
        	mov	yweg,eax               
        	@schon_drinn:    ;backtimer wird im timewr gesetzt 18*64+59;15
        	cmp	rowsplayed,18*64+61;59
        	jb	@nichtgroesser         
        	  	mov   	eax,backtimer  
		 	shl  	eax,4
        	  	mov  	ebx,255*16
        	  	sub	ebx,eax  
        	  	mov 	zweg,1600
        	  	sub    	zweg,ebx       
        	@nichtgroesser:                
 		mov	eax,timer
		mov	gradx,ax
		mov	grady,ax
 		mov	gradz,ax
 	  	mov	bx,gradx
 	  	mov	di,grady
		add	di,di          
 	  	mov    	si,128;gradz           
 	  	movzx	ebp,anzahlvektor       
 	  	@morphingloop_text_phong:      
 	  	     	push   	di bx si       
 	  	  	mov  	ax,[zrot+ebp*2]
 	  		sar  	ax,4           
 		      	add  	di,ax          
	 	       	mov 	ax,[xrot+ebp*2]
	 	      	sar 	ax,3           
   	 		add	bx,ax          
   	 		mov	ax,[yrot+ebp*2]
   	  	     	sar  	ax,4           
   	  	       	add	si,ax          
   	  	  	call  	rotieren       
   	  	      	call	rotatenormals  
	  	       	pop 	si bx di       
 	  	  	dec	ebp            
 	  	jns	@morphingloop_text_phong
 	 	call	filter_sichtbare_faces  
	 	mov	lm,0           
	 	movsx	eax,anzahlsichtbar     
   		cmp	rowsplayed,19*64+20;19*64+21
   	 	jae    	@part_ende     
	 	or	eax,eax                 
	 	js 	@nicht_gesetzt          
   	 	mov	rm,eax                  
   	 	call	quicksort              
   	  	call  	drawall_text_phong     
   	  	call 	setze_hinter           
   	  	@nicht_gesetzt:                
   	   	jmp    	@zeichne3d_text_morph
@part_ende:                            
   	call	waitdisplay                    
   	call	waitretrace                    
   	call	clear                          
ret